(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("hoist-non-react-statics"), require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["hoist-non-react-statics", "react"], factory);
	else if(typeof exports === 'object')
		exports["SizeWatcher"] = factory(require("hoist-non-react-statics"), require("react"));
	else
		root["SizeWatcher"] = factory(root["hoistNonReactStatics"], root["react"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE_hoist_non_react_statics__, __WEBPACK_EXTERNAL_MODULE_react__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.js");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/index.js":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isForwardRef", function() { return isForwardRef; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "forwardRefSymbol", function() { return forwardRefSymbol; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "forwardRefFactory", function() { return forwardRefFactory; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "withForwardRef", function() { return withForwardRef; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var hoist_non_react_statics__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("hoist-non-react-statics");
/* harmony import */ var hoist_non_react_statics__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(hoist_non_react_statics__WEBPACK_IMPORTED_MODULE_1__);



/**
 * Tests if Component is produced by forwardRef function
 * @param Component
 * @returns {boolean}
 */
const isForwardRef = Component => Component.$$typeof && typeof Component.render === 'function';

/**
 * Use just a string for now (react 16.3), since react doesn't support Symbols in props yet
 * https://github.com/facebook/react/issues/7552
 * @type {string}
 */
const forwardRefSymbol = '__forwardRef__';

/**
 * Wraps passed component with react 'forwardRef' function, which produce new component with type 'object' and structure like so:
 * { $$type: Symbol(), render: function }
 * Assigns (hoists) static methods of passed component to result forward component using 'hoist-non-react-statics' module.
 *
 * @param {Object|Function} Component - Component to wrap with forwardRef
 * @param {Object} [options] - Optional parameters
 * @param {String} [options.displayName] - Name of the result component that will be used in devtools.
 *                                         Will be taken from source component if omitted
 * @param {Object|Function} [options.hoistSource] - Source for taking static methods for assigning them to result component.
 *                                         In case you want to wrap with forwardRef another wrapper of original component,
 *                                         but methods should be copied from original
 * @param {Object} [options.hoistExclude] - Object to exclude some methods from hoisting, third parameter of hoist-non-react-statics module.
 *                                         By default excludes forwardRef component properties in case we wrap another forwardRef component.
 *                                         Until https://github.com/mridgway/hoist-non-react-statics/issues/48 is resolved
 * @returns {Object}
 */
const forwardRefFactory = (Component, { displayName, hoistSource = Component, hoistExclude = { $$typeof: true, render: true } } = {}) => {
  const forwardFn = (props, ref) => react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(Component, Object.assign({ [forwardRefSymbol]: ref }, props));

  forwardFn.displayName = displayName || Component.displayName || Component.name;

  const forwarder = Object(react__WEBPACK_IMPORTED_MODULE_0__["forwardRef"])(forwardFn);

  hoist_non_react_statics__WEBPACK_IMPORTED_MODULE_1___default()(forwarder, hoistSource, hoistExclude);

  return forwarder;
};

/**
 * Simple HOC that uses forwardRefFactory
 * @param [options] - Options for forwardRefFactory
 * @returns {Object}
 */
function withForwardRef(options) {
  return Component => forwardRefFactory(Component, options);
}

/***/ }),

/***/ "hoist-non-react-statics":
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_hoist_non_react_statics__;

/***/ }),

/***/ "react":
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_react__;

/***/ })

/******/ });
});
//# sourceMappingURL=react-forwardref-utils.js.map